﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;

namespace SeriTile
{
    internal class AStarQueue
    {

	    System.Collections.Generic.List<PathMapTile> m_heap = new List<PathMapTile>();

        public PathMapTile pop()
	    {
            if(m_heap.Count == 0)
                return null;
		    PathMapTile tile= m_heap[0];
            m_heap[0] = m_heap[m_heap.Count-1];
		    m_heap.RemoveAt(m_heap.Count-1);
		    m_heap.Sort(new PathMapTile.Sorter());

		    return tile;
	    }

        public void push(PathMapTile tile)
	    {
		    m_heap.Add(tile);
		    m_heap.Sort(new PathMapTile.Sorter());
	    }

        public void update(PathMapTile element)
	    {
            int i=0;
            foreach(PathMapTile tile in m_heap)
            {
                if(tile.x == element.x && tile.y == element.y)
                {
                    if (i >= m_heap.Count - 1)
                        return;
                    m_heap.Sort(i,m_heap.Count-i,new PathMapTile.Sorter());
                    return;
                }
                i++;
            }

	    }

	    public bool isEmpty()
	    {
		    return m_heap.Count==0;
	    }
    }
}
