﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SeriTile
{
    public class Observable
    {
        public delegate void OnUpdateHandler(Observable sender, EventArgs eventArgs);
        public OnUpdateHandler OnUpdate;

        protected void Update()
        {
            if(OnUpdate != null)
                OnUpdate(this, new EventArgs());
        }

        protected void Update(EventArgs args)
        {
            if (OnUpdate != null)
                OnUpdate(this, args);
        }
    }
}
