﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace SeriTile
{
    public abstract class ITile
    {
        public abstract Rect Rect { get;}
        public abstract Point Offset { get; }
        public abstract WriteableBitmap Image { get; }
        public abstract WriteableBitmapExtensions.BlendMode BlendMode { get; internal set; }
        public abstract void Blit(WriteableBitmap bitmap, Point blitPoint);
        public abstract void Blit(WriteableBitmap bitmap, Point blitPoint, Color color);
    }
}
